# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import playerlib
import popuplib
import cmdlib
# ============================================================================================================================================================= #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/base/manager')
block  = es.import_addon('sam/base/pcontrol')

# * VARIABLES
values      = [0,800,2800,5000,10000,16000]
filters     = {'#all':'#alive','#alive':'#alive','#ct':'#ct','#t':'#t'}
cashtag     = '#greenCASH'
cash_hudtag = 'CASH'

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### CMDs ###
	cmdlib.registerSayCommand('!cash', cashCMD,'SAM')
	cmdlib.registerSayCommand('!sam_cash', cashCMD,'SAM')

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### Unreg ###
	cmdlib.unregisterSayCommand('!cash')
	cmdlib.unregisterSayCommand('!sam_cash')

	### POPUPS ###
	func.popupDelete('get_targets')
	func.popupDelete('get_cash')

# ============================================================================================================================================================= #
# ======================================================================= CMD BLOCKS ========================================================================== #
# ============================================================================================================================================================= #
def cashCMD(userid, args):
	admin = playerlib.getPlayer(userid)
	if admins.isAdmin(admin.steamid):
		if admins.checkAccess(admin.steamid, 'Give Cash'):
			if args:
				try:
					if int(args[1]) in range(0,16001):
						if not args[0] in filters: give_cash(admin, {'target':playerlib.getPlayer(es.getuserid(args[0])),'cash':args[1]}, None, 0, 1)
						else:
							list = playerlib.getPlayerList(filters[args[0]])
							for ply in list: give_cash(admin, {'target':ply,'cash':args[1]}, None, 1, 1)
							if len(list) > 0: func.tell('#all', func.lang_pcontrol('cash_to_targets', {'num':len(list),'cash':args[1]}), cashtag)
					else: func.hudhint(userid, func.lang_pcontrol('cash_not_in_range'), cash_hudtag)
				except (ValueError, IndexError): func.hudhint(userid, func.lang_pcontrol('cash_not_in_range'), cash_hudtag)
				except: func.hudhint(userid, func.lang_pcontrol('target_not_exist', {'target':args[0]}), cash_hudtag)
			else: block.function(userid, 'Give Cash', None)

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def moduleAction(userid):
	func.popupDelete('get_targets')
	popup = popuplib.easymenu('get_targets', None, getTargets)
	popup.c_beginsep = func.pline
	popup.c_pagesep  = func.pline
	popup.settitle('%s | SAM %s\n \n :: %s ' % (func.menutitle, es.ServerVar(func.version), func.lang_titles('pcontrol_givecash')))
	popup.setdescription('\n # %s' % func.lang_titles('pcontrol_givecash_howmuch_desc'))
	popup.addoption('all', func.lang_pcontrol('givecash_giveto_all'))
	for ply in playerlib.getPlayerList('#alive'): popup.addoption(ply, ply.name)
	popup.submenu(10, 'pcontrol')
	popup.send(userid)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def getTargets(userid, choice, popup):
	func.popupDelete('get_cash')
	popup = popuplib.easymenu('get_cash', None, give_cash)
	popup.c_beginsep = func.pline
	popup.c_pagesep  = func.pline
	popup.settitle('%s | SAM %s\n \n :: %s ' % (func.menutitle, es.ServerVar(func.version), func.lang_titles('pcontrol_givecash')))
	popup.setdescription('\n # %s' % func.lang_titles('pcontrol_givecash_howmuch_desc'))
	num = 0
	while num < 16800:
		popup.addoption({'cash':num,'target':choice}, num)
		num += 800
	popup.submenu(10, 'get_targets')
	popup.send(userid)

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def give_cash(userid, choice, popup, cmd=0, menu=0):
	if choice['target'] == 'all':
		for player in playerlib.getPlayerList('#all'):
			if admins.checkImmunity(es.getplayersteamid(userid), player.steamid, 0): player.setCash(int(choice['cash']))
		func.tell('#all', func.lang_pcontrol('givecash_to_all', choice))
		block.modulePopup(userid)
	else:
		target = choice['target']
		target.setCash(int(choice['cash']))
		if cmd == 0: func.tell('#all', func.lang_pcontrol('givecash_to_target', {'target':target.name,'cash':choice['cash']}))
		if menu == 0: block.function(userid, 'Give Cash', None)

# ============================================================================================================================================================= #